c------------------------------------------------------------------
c     prepare coordinate file to use in other programs
c           output code(jout)          meaning
c                        0             standard shelx output 
c                        1             standard crystals output
c
      subroutine export(ier)
      character cff
      character fname(9)*80,ext(9)*4,line*80
      common/dotdat/ fname,ext
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /xdata/ store(244000)
      common /dd/ a2,b2,c2,ab,ac,bc,bterm,wscale
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
*     common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),ptss
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
*     common /tab3/ ijt(6,2),iit(6),numpr(29),ktlsq(28)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      common/sym/isn(2,3,24),tsn(3,24),nnsym,pts,ksys,ncent,latt,s3s2,
     *          emme,s3s2p
      common/rc/p(6),cx(9),dumm(9)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
*     dimension xo(11),xn(11),key(10),newvet(48,3)
c
      if (icomat.eq.1) then
                         write(cff,'(i1)') kff
                         write(lo,10) cff,itle
                       else
                         write(lo,15) itle
                       endif
c
      call lastplot(rfac)
c
      if (jrest.ne.0) then
                        lline=7
                        line(1:7)='restart'
                        call modque(line,lline)
                        return
                       endif
c
   10 format(///,a1 ,120('+'),//,
     1 39h SIR92 : Export routine                ,68x,14hRelease  93.02
     2 ,//,20x,20a4,/,1h ,120('+'),/)
   15 format(///,1h ,120('-'),/,
     1 39h SIR92 : Export routine                ,68x,14hRelease  93.02
     2 ,//,20x,20a4,//)
      call srlin (15,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                    call xspinb
                    idisp=1
                    call sfl15(nats,idisp,numset,interp)
                  else
                    write(lo,20)
                    ier=-1
                    return
                  endif
      call direxp(igraph,numset,kcompl,ier)
      if (ier.lt.0) return
  20  format(/,' *** error *** No coordinates in direct access file',/)
c----
      call srlin (7,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call ysfl07(nrifl,mmm,mmmz,npseud,iy)
                      bterm=bt
                      wscale=sc
                    else
                      write(lo,30)
                      ier=-1
                      return
                    endif
  30  format(/,' *** error *** No reflections in direct access file',/)
c-- if m.s.c. environment ..........(kenvir = 2)
c-- if enraf-nonius environment ....(kenvir = 1) 
      itype=0
      iform=1
      jop=jopen(jhost,fname(3),nlen,itype,iform,ierr)
      if (jop.lt.0) go to 9000
c
      rfac=errem*100.0
      if (rfac.gt.0.0) write(lo,35) nats,rfac,maxcyc
      if (kenvir.ne.0) then
                         if (kenvir.eq.1) then
                                            call outenr(izpk)
                                            write(lo,80) fname(3)
                                          endif
                         if (kenvir.eq.2) then
                                            call outmsc(izpk)
                                            write(lo,85) fname(3)
                                          endif
                       else
                         if (jout.ge.0) then
                       endif
c
      write(lo,40)
      if (jout.eq.0) then
                        call outshe
                        write(lo,70) fname(3)
                     else
                        call outcry(kcompl)
                        write(lo,75) fname(3)
                     endif
      if (igraph.eq.1) then
                         write(lo,50) fname(4)
                         call outmold
                       endif
      if (igraph.eq.2) then
                         write(lo,60) fname(4)
                         call outsha
                       endif
      if (igraph.eq.3) then
                         write(lo,65) fname(4)
                         call outmolp
                       endif
      if (igraph.eq.4) then
                         write(lo,68) fname(4)
                         call outxyz
                       endif
                       endif
      return
c
   35 format(//,3x,'Final R value using',i4,' atoms is ',f7.2,'%',
     *             '  after ',i2,'  cycles.')
   40 format(///,'   Atoms informations files produced:',//,
     *           '   Format        File Name ',/)
   50 format(    '   MOLDRAW       ',a)
   60 format(    '   SCHAKAL       ',a)
   65 format(    '   MOLPLO        ',a)
   68 format(    '   Cartesian     ',a)
   70 format(    '   SHELX-92      ',a)
   75 format(    '   CRYSTALS      ',a)
   80 format(    '   MolEN         ',a)
   85 format(    '   TeXan         ',a)
 9000 write(lo,9010) ierr,fname(3)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      end
c
c---------------------------------------------------------------------
      subroutine direxp(igraph,numset,kcompl,ier)
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
c 
c-- set default values
c
      kcompl=0
      igraph=3
      mset=numset
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c-- directives with alphanumeric parameters
      if (dire(1:4).eq.'crys') then
          jout=1
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'comp') then
          jout=1
          kcompl=1
          go to 100
          endif
      if (dire(1:4).eq.'shel') then
          jout=0
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'texa') then
          jout=-1
          kenvir= 2
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'mole') then
          jout=-1
          kenvir= 1
          if (lenp.gt.0) fname(3)=line
          go to 100
          endif
      if (dire(1:4).eq.'mold') then
          igraph=1
          if (lenp.gt.0) fname(4)=line
          go to 100
          endif
      if (dire(1:4).eq.'scha') then
          igraph=2
          if (lenp.gt.0) fname(4)=line
          go to 100
          endif
      if (dire(1:4).eq.'molp') then
          igraph=3
          if (lenp.gt.0) fname(4)=line
          go to 100
          endif
      if (dire(1:3).eq.'xyz' ) then
          igraph=4
          if (lenp.gt.0) fname(4)=line
          go to 100
          endif
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
 8000 continue
      return
      end
c-------------------------------------------------------------------
c-- crystals output 
c
      subroutine outcry(kcompl)
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /xdata/ store(244000)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),pts
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/rc/p(6),cx(9),dumm(9)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
c
      if (kcompl.eq.1) then
                         write(jhost,20) itle
                         write(jhost,30) (cx(i),i=1,6)
                         write(jhost,40) (nt(i),i=1,16)
                         write(jhost,50) (nalf(i),nw(i),i=1,nk)
                         write(jhost,60) fname(2)
                         rfac=errem*100.0
                         write(jhost,70) (itle(i),i=1,19),nats,
     *                                   numset,rfac,fosog
                       endif
   20 format('#title ',20a4)
   30 format('#quickstart ',/,'cell ',3f8.3,3f8.2)
   40 format('spacegroup ',16a1)
   50 format('content ',8(a2,i4,2x))
   60 format('file ',a,/,'format (3f4.0,2f8.2) ',/,'end')
   70 format('# ',19a4,/,'# number of atoms = ',i5,' for set no. ',i5,
     *'  final R value = ',f7.2,'%',
     *       /,'# ',/,'#list 28 ',/,'minima /fo/ = ',f10.3,/,'end ')
c
c-- crystals output  -  list 5
c
      write(jhost,80) 
   80 format('#list 5 ',/,
     *       'read natom = 0',/,
     *       'end',/,
     *       '#edit ')
      denom=8.0*pi*pi
      isel=0
      do 110 i=1,nats
      itp=iabs(nz(i)/100)
      if (itp.ne.0) then
                      itp=nalf(itp)
                      uiso=bfac(i)/denom
                      write(jhost,90) itp,i,x(5,i),uiso,(x(j,i),j=1,3)
                    else
                      isel=1
                      uiso=bt/denom
                      write(jhost,100) i,x(5,i),uiso,(x(j,i),j=1,3)
                    endif
   90 format('atom ',a2,i4,5x,5f10.4)
  100 format('atom q ', i4,5x,5f10.4)
  110 continue
      if (isel.eq.1) write(jhost,'(18hselect type ne q  )')
c
c-- crystals output  -  list 12
c
      if (kcompl.eq.1) write(jhost,120)
  120 format(3hend,/,8h#list 12,/,18hblock x's  u[iso]  )
      write(jhost,130)
  130 format('end ',/,'#use last')
      return
      end
c
c---------------------------------------------------------------------
c-- shelx output
      subroutine outshe
      character fmt*4,line*4,linl*80,xyz(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/rc/p(6),cx(9),dumm(9)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension x2(5),kpunt(8,2)
      dimension abc(3),ang(3),latsx(7)
      data xyz/'X','Y','Z'/
      data latsx / 1,5,6,7,2,4,3 /
c
c
      write(jhost,100) (itle(i),i=1,18)
  100 format('TITL    ',18a4)
      do 110 i=1,3
         abc(i)=cx(i)
         ang(i)=cx(i+3)
  110 continue
      ilat=latsx(lat)
      if (icent.eq.0) then
                        ilat=-ilat
                        nop2=noper
                      else
                        nop2=noper*2
                      endif
      wl=0.71069
      p005=0.005
      write(jhost,120) wl,abc,ang,nop2,(p005,i=1,6)
  120 format('CELL  ',f8.5,2x,6f9.3,/,
     *       'ZERR  ',i8,2x,6f9.3)
      write(jhost,130) ilat
  130 format('LATT ',2i2)
c
c procedura che scrive la parte relativa alla simmetria del file
c di input a shelx
      if (noper.gt.1) then
        do 170  k=2,noper
             linl(1:4)='SYMM' 
               do 140 i=5,80
  140             linl(i:i)=' '
               ip=6
               do 160 j=1,3
                 iplus=0
                 if (tmat(k,j).gt.0.001) then
                   write(linl(ip:),'(f8.5)') tmat(k,j)
                   ip=ip+8
                   iplus=1
                 endif
                 do 150 i=1,3
                   ii=kmat(k,j,i)
                   if (ii.ne.0) then
                     if (ii.lt.0) then
                         linl(ip:ip)='-'
                         ip=ip+1
                     else
                         if (iplus.eq.1) then
                           linl(ip:ip)='+'
                           ip=ip+1
                         endif
                     endif
                     write(linl(ip:ip),'(a1)') xyz(i)
                     ip=ip+1
                     iplus=1
                   endif
 150             continue
                 if (j.lt.3) then
                  write(linl(ip:ip),'(a1)') ','
                  ip=ip+1
                  iplus=0
                 endif
 160           continue
               write(jhost,'(a)') linl(1:79)
               ip=1
               iplus=0
 170  continue
      endif
      do 180 i=1,nk
      do 180 j=1,2
  180 kpunt(i,j)=0
      ish=0
      do 190 i=1,nk
      if (no(i).eq.6) then
                        ish=ish+1
                        kpunt(ish,1)=i
                        kpunt(i,2)=ish
                      endif
  190 continue
      do 200 i=1,nk
      if (no(i).eq.1) then
                        ish=ish+1
                        kpunt(ish,1)=i
                        kpunt(i,2)=ish
                      endif
  200 continue
      do 205 i=1,nk
      if (kpunt(i,1).eq.0) then
                             ish=ish+1
                             kpunt(ish,1)=i
                             kpunt(i,2)=ish
                           endif
  205 continue
      write(linl(1:38),210) (nalf(kpunt(i,1)),i=1,nk)
      call ucase(linl(1:38))
      write(jhost,'(a)') linl(1:38)
  210 format('SFAC  ',8(2x,a2))
      write(jhost,220) (nw(kpunt(i,1)),i=1,nk)
  220 format('UNIT  ',8i4)
      write(jhost,240)
  240 format('MERG      2',/,
     *       'OMIT      4',/,
     *       'L.S.      4',/,
     *       'LIST      1',/,
     *       'FMAP      2',/,
     *       'PLAN     25',/,
     *       'FVAR    1.0')
      denom=8.0*pi*pi
      do 260 i=1,nats
      izpki=iabs(nz(i))/100
      if (izpki.ne.0) then
                        izpki=kpunt(izpki,1)
                        izpk2=kpunt(izpki,2)
                        uiso=bfac(i)/denom
                        do 245 j=1,3
  245                   x2(j)=x(j,i)
                        write(line(1:2),270) nalf(izpk2)
                        line(3:4)='  '
                        x2(4)=x(5,i)+10.0
                        in=2
                        if (i.gt.99) in=3
                        write(fmt,280) in
                        write(line(5-in:4),fmt) i
                        do 250 j=1,4
                        if (line(j:j).eq.' ') line(j:j)='0'
  250                   continue
                        call ucase(line)
                        write(jhost,290) line,izpki,(x2(j),j=1,4),uiso
                      endif
  260 continue
  270 format(a2)
  280 format(2h(i,i1,1h))
  290 format(a4,i5,5f10.5)
      write(jhost,300)
  300 format('           ',/,
     *       'HKLF      4',/,
     *       'END        ')
      uiso=bt/denom
      do 360 i=1,nats
      izpki=iabs(nz(i))/100
      if (izpki.eq.0) then
                        izpki=1
                        do 345 j=1,3
  345                   x2(j)=x(j,i)
                        line(1:2)='Q '
                        line(3:4)='  '
                        x2(4)=x(5,i)+10.0
                        in=2
                        if (i.gt.99) in=3
                        write(fmt,280) in
                        write(line(5-in:4),fmt) i
                        do 350 j=1,4
                        if (line(j:j).eq.' ') line(j:j)='0'
  350                   continue
                        write(jhost,290) line,izpki,(x2(j),j=1,4),uiso
                      endif
  360 continue
      return
      end
c---------------------------------------------------------------------
c
c subroutine for m.s.c. environment
      subroutine outmsc(izpk)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      dimension izpk(500)
   
      write(jhost,75)nats,numset,(kstory(i),i=1,5)
   75 format(20h SIR88 Release 93.02,i5,20h  peaks for set no. ,i5,5i5)
      do 80 i=1,nats
      kheig=nint(x(4,i))
      izpki=izpk(i)
      if (izpki.gt.0) 
     *write(jhost,78) nalf(izpki),i,
     *(x(j,i),j=1,3),kheig
   78 format(a2,i5,3f10.5,i7)
   80 continue
      return
      end
c
c---------------------------------------------------------------------
c-- subroutine for enraf-nonius environment .....
      subroutine outenr(izpk)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension xo(11),xn(11),key(10),newvet(48,3),izpk(500)
c
      write(jhost,75)nats,numset
   75 format(20h SIR88 Release 93.02,i5,20h  peaks for set no. ,i5,5i5)
      denom=8.0*pi*pi
      do 90 i=1,nats
      do 81 j=1,3
   81 xo(j)=x(j,i)
      iser=i
      itype=nalf(izpk(i))
      if (itype.eq.0) go to 90
      k=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
      occ=1.0/float(key(10))
      kheig=nint(x(4,i))
      izpki=izpk(i)
      uiso=bfac(i)/denom
      if (izpki.gt.0) 
     *   write(jhost,85) nalf(izpki),i,occ,uiso,
     *   (x(j,i),j=1,3),kheig,(key(j),j=1,9)
   85 format(1h ,a2,i3,5f8.5,i7,9i3)
   90 continue
      return
      end
c----------------------------------------------------------------------
c     prepare input file for MOLDRAW
c
      subroutine outmold
      character line*5,space*16
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /xdata/ store(160000),dummpc(84000)
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),dumm(9)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      dimension ivet(9)
      dimension istore(160000)
      equivalence (store(1),istore(1))
c
      itype=0
      iform=1
      jop=jopen(jgrap,fname(4),nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      write(jgrap,1040) (itle(i),i=1,17),(cx(i),i=1,6)
 1040 format('TITLE',/,17a4,/,'CELL',/,6f10.3,/,'COSYMB')
      ind=1
      mdm=6
      do 1030 i=1,nats
      icveti=nz(i)
      if (nz(i).lt.0) then
                           kfrag=10000+i
                           icveti=0
                        else
                           kfrag=mod(icveti,100)*1000+i
                        endif
      iz=icveti/100
      istore(ind)=iz
      istore(ind+1)=i
      store(ind+2)=x(1,i)
      store(ind+3)=x(2,i)
      store(ind+4)=x(3,i)
      store(ind+5)=kfrag
      ind=ind+mdm
 1030 continue
      ind=1
      jump=6
      call sortz(ind,nats,mdm,jump)
      do 1100 i=1,nats
      do 1105 n=1,5
      line(n:n)=' '
 1105 continue
      if (istore(ind).ne.0) then
                               write(line(1:2),'(a2)') nalf(istore(ind))
                               call ucase(line)
                             else
                               line(1:1)='H'
                             endif
      write(line(3:5),'(i3)') istore(ind+1)
      call xcmprp(line,k)
      write(jgrap,1120) i,line,(store(ind+j),j=2,4)
 1120 format(i4,2x,a5,3f10.3)
      ind=ind+mdm
 1100 continue
      write(space,'(16a1)') nt
      call ucase(space)
      call xcmprp(space,k)
      write(jgrap,1110) space
 1110 format('   0  0         0         0         0',/,
     *       'GROUP',/,a16,/,'SYMNUM')
      iss=-1
      do 1180 ii=1,icent+1
      iss=-iss
      do 1170 k=1,noper
      l=0
      do 1160 i=1,3
      do 1160 j=1,3
      l=l+1
 1160 ivet(l)=nint(soper(i,j,k))*iss
      write(jgrap,1190) (soper(i,4,k),i=1,3),ivet
 1170 continue
 1180 continue
 1190 format(3f10.5,3(3i4,4x))
      write(jgrap,1200)
 1200 format('  -1.       -1.       -1.        0   0   0       0   0   0
     *       0   0   0 ')
      close (jgrap)
      return
 9000 write(lo,9010) ier,fname(4)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      return
      end
c-----------------------------------------------------------------------
c     prepare input file for MOLPLO
c
      subroutine outmolp
      character line*6, reticoli*7
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),dumm(9)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      dimension ivet(9)
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common / data/  store (5000)
      dimension radii(8)
c
      reticoli='pabcifr'
      call yfl03
      m3=l3
      do 24  i= 1,n3
      radii(i) = store(m3+15)
      m3=m3+md3
   24 continue
      if (no(1).eq.1) then
                        jlig=1
                      else
                        jlig=0
                      endif
c
      itype=0
      iform=1
      jop=jopen(jgrap,fname(4),nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      write(jgrap,1040) (itle(i),i=1,20),(cx(i),i=1,6),nats
 1040 format(20a4,/,6f10.3,/,i5)
      ind=1
      mdm=6
      do 1030 i=1,nats
      icveti=iabs(nz(i))
      iz=icveti/100
      line(1:6)='      '
      if (iz.gt.0) then
          write(line(1:2),'(a2)') nalf(iz)
      else
          line(1:2)='Q '
      endif
      call ucase(line)
      write(line(3:5),'(i3)') i
      call xcmprp(line,k)
      if (iz.gt.0) then
          Bond=2*radii(iz)+0.3
          Radius=radii(iz) / 3.0
          iCol=iz - jlig
      else
          Bond=0.1
          Radius=0.1
          iCol=7
      endif
      line(6:6)=','
      write(jgrap,1120) line,(x(j,i),j=1,3),Bond,Radius,iCol
 1120 format(a6,5f10.5,i4)
 1030 continue
      write(jgrap,1130) noper*(icent+1)
 1130 format(i5)
      iss=-1
      do 1180 ii=1,icent+1
      iss=-iss
      do 1170 k=1,noper
      l=0
      do 1160 i=1,3
      do 1160 j=1,3
      l=l+1
 1160 ivet(l)=nint(soper(i,j,k))*iss
      write(jgrap,1190) (soper(i,4,k),i=1,3),ivet
 1170 continue
 1180 continue
 1190 format(3f10.5,3(3i4,4x))
      write(jgrap,2000) reticoli(lat:lat)
 2000 format(a1)
      close (jgrap)
      return
 9000 write(lo,9010) ier,fname(4)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      return
      end
c-----------------------------------------------------------------------
c     prepare input file for SCHAKAL
c
      subroutine outsha
      character line*5
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /data/ store(5000)
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),dumm(9)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      dimension ivet(12),vet(12)
      dimension istore(5000)
      equivalence (store(1),istore(1))
      equivalence (vet(1),ivet(1))
c
      itype=0
      iform=1
      jop=jopen(jgrap,fname(4),nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      write(jgrap,1040) (itle(i),i=1,17),(cx(i),i=1,6)
 1040 format('TITLE',3x,17a4,/,'CELL',3x,6f10.3)
      ind=1
      mdm=6
      do 1030 i=1,nats
      icveti=nz(i)
      if (icveti.eq.0) go to 1030
      if (nz(i).le.0) icveti=0
      iz=icveti/100
      istore(ind)=iz
      istore(ind+1)=i
      store(ind+2)=x(1,i)
      store(ind+3)=x(2,i)
      store(ind+4)=x(3,i)
      do 1105 n=1,5
      line(n:n)=' '
 1105 continue
      if (icveti.gt.0) then
                         write(line(1:2),'(a2)') nalf(istore(ind))
                       else
                         write(line(1:2),'(2hH )') 
                       endif
      call ucase(line)
      write(line(3:5),'(i3)') istore(ind+1)
      call xcmprp(line,k)
      write(jgrap,1120) line,(store(ind+j),j=2,4)
 1120 format('ATOM',3x,a5,3f10.3)
      ind=ind+mdm
 1030 continue
      write(jgrap,'(a3)') 'END'
      close (jgrap)
      return
 9000 write(lo,9010) ier,fname(4)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      return
      end
c---------------------------------------------------------------------
c     prepare input file for XYZ
c
      subroutine outxyz
      character line*5
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /data/ store(5000)
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/rc/p(6),cx(9),dumm(9)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nasu,f(9),nalf(8)
      common /erl/ ksmat(48,3,3),tmat(48,3),nt(16),lsys,ngen
     *,irot(48,48),kvet(10),jvet(8),nori,modul(3),nss(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *        kpol,jsys,lat,indv(32),mpv(64),jspini,dmins,ncawu,ncwu
      dimension ivet(12),vet(12),amat(3,3),xyz(3),r(3)
      dimension istore(5000)
      equivalence (store(1),istore(1))
      equivalence (vet(1),ivet(1))
c
      itype=0
      iform=1
      jop=jopen(jgrap,fname(4),nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      write(jgrap,100) nats,(itle(i),i=1,20)
  100 format(i5,/,20a4)
      alfa=cx(4)*dtor
      beta=cx(5)*dtor
      gamm=cx(6)*dtor
      a1=cos(alfa)
      a2=cos(beta)
      a3=cos(gamm)
      b1=sin(alfa)
      b2=sin(beta)
      b3=sin(gamm)
      amat(1,1) =  cx(1) * b2
      amat(1,2) = -cx(2) * b1 * a3
      amat(1,3) =  0.0
      amat(2,1) =  0.0
      amat(2,2) =  cx(2) * b1 * b3
      amat(2,3) =  0.0
      amat(3,1) =  cx(1) * a2
      amat(3,2) =  cx(2) * a1
      amat(3,3) =  cx(3)
      do 400 i=1,nats
      do 200 j=1,3
  200 r(j)=x(j,i)
      call molt1(amat,r,xyz)
      icveti=iabs(nz(i))/100
      if (icveti.eq.0) then
                          line(1:2)='q '
                        else
                          write(line(1:2),'(a2)') nalf(icveti)
                        endif
      call ucase(line(1:2))
      write(jgrap,300) line(1:2),(xyz(k),k=1,3)
  300 format(a2,3x,3f15.7)
  400 continue
      close (jgrap)
      return
 9000 write(lo,9010) ier,fname(4)
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      return
      end
c---------------------------------------------------------------------
      subroutine modque(line,lline)
      character line*80
      character blank,digit*12,card(100)*80,ffile*80
      character beg,commen,allcom(25)*14
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common /charas/ beg,commen,allcom
c
      jfound=0
      do 10 i=1,25
      if (line(1:lline).eq.allcom(i)(1:lline)) jfound=i
   10 continue
      if (jfound.eq.0) stop 'Programming error #1'
      jline=3
      line(1:3)='end'
      jend=0
      do 20 i=1,25
      if (line(1:jline).eq.allcom(i)(1:jline)) jend=i
   20 continue
      jlast=0
      do 30 i=1,200
      if (icomq(i,1).eq.jend) jlast=i
   30 continue
      if (jlast.eq.0) stop 'Programming error #2'
      ncomm=jlast-icomat+1
      j=jlast
      do 40 i=1,ncomm
      icomq(j+1,1)=icomq(j,1)
      icomq(j+1,2)=icomq(j,2)
      j=j-1
   40 continue
      icomq(icomat,1)=jfound
      icomq(icomat,2)=0
      icomat=icomat-1
      ipcom = ipcom + 1
c
      return
      end
c------------------------------------------------------------------
      subroutine restar(ier)
      character*80 name
      character cff
c
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/inpcl/ntype,ttype(10,5),nprojx,nbond,dmaxi,radnew(8)
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),duma(5000),dummpc(84000)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isn(2,3,24),tsn(3,24),nnsym,pts,ksys,ncent,latt,s3s2,
     *          emme,s3s2p
      common /ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /buffer/ ndel(200),niz(200),nop,dummr(114)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension izpk(500)
c
      nbond=1
      krecy=1
      write(cff,'(i1)') kff
      write(lo,10) cff,itle
   10 format(///,a1 ,120('+'),//,
     1 39h Restart routine                       ,68x,14hRelease  93.02
     2 ,//,20x,20a4)
c++++++
      itype=1
      iform=2
      jop=jopen(jrel ,name,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      jop=jopen(ifour,name,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9010
c
      call dirres(jcompl,ier)
      if (ier.lt.0) return
      erreo=errem
      if (jrest.eq.0) then
                        call change0(ier)
                        if (ier.lt.0) return
                        call change1(ier)
                        if (ier.lt.0) return
                      endif
c
      numb2=0
      istop=0
      jrest=max0(jrest,jcompl)
      erreo = errem
      if (jrest.eq.1) then
                        modef = maxcyc + 3
                      else 
                        modef = maxcyc + 50
                      endif 
      jrecyc = modef - 1
      do 200 mode=maxcyc+2,modef
           if (istop.eq.1) go to 200
           if (mode.eq.modef) istop=1
           call defco(nsize)
           call fft(numb2,mode,anat,ccfom,nsize,ier)
           if (ier.ne.0) istop=1 
  200 continue
      if (ier.lt.0) return
c
c-- stop recycling
c
      call stopr(host,izpk,mode)
c
      if (ier.lt.0) return
      close(jrel )
      close(ifour)
      return
 9000 continue
      write(lo,9020) ier,jrel
      ier=-1
      return
 9010 continue
      write(lo,9030) ier,ifour
      ier=-1
 9020 format(' *** error ***  open error on scratch file jrel, code ='
     *,i5,',  channel =',i5)
 9030 format(' *** error ***  open error on scratch file ifour, code ='
     *,i5,',  channel =',i5)
      return
      end
c----------------------------------------------------------------------
      subroutine dirres(jcompl,ier)
      character line*80,dire*80,diret*80
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,ifper,iprin,iflag
      common /ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /buffer/ ndel(200),niz(200),nop,dummr(114)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
c-- set default values
c
      jcompl=0
      nsec=1
      jmpsie=1
      jpatt=0
      npc=0
      factr= 1.0/3.0
      it4=0
      level = 100
      xlim(1)=1.0
      xlim(2)=1.0
      xlim(3)=1.0
      do 10 i=1,200
      ndel(i) = 0
      niz (i) = 0
   10 continue
      call sfl15(nats,idisp,idumm,interp)
c
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call lcase(line)
      call cutst(line,lenp,dire,lend)
      if (dire(1:3).eq.'com') then
          jcompl=2
          go to 100
          endif
      if (dire(1:3).eq.'pri') then
          iprin=4
          go to 100
          endif
      if (dire(1:3).eq.'del') then
          kjump=0
          call getcod(line,ncod,iz,kjump,ier) 
          if (ier.lt.0) go to 9000
          ndel(ncod)=-1
          niz (ncod)=iz
          jrest=0
          go to 100
          endif
      if (dire(1:3).eq.'ren'.or.dire(1:3).eq.'rel') then
          kjump=0
          call getcod(line,ncod,iz,kjump,ier)
          if (ier.lt.0) go to 9000
          niz (ncod)=iz
          kjump=1
          call getcod(line,ncod,iz,kjump,ier)
          if (ier.lt.0) go to 9000
          ndel(ncod)=iz
          jrest=0
          go to 100
          endif
      write(lo,6500) diret
 6500 format(' wrong directive on following line:',/a)
      ier=-1
      return
 8000 continue
      return
 9000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
      end
c----------------------------------------------------------------------
      subroutine getcod(line,ncod,iz,kjump,ier)
      character line*80,dire*80,buf1*2,buf2*2
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /atoms/ x(5,200),nz(200),idumx(21)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,kat,f(9),nalf(8)
      dimension vet(40),ivet(40)
c
      call lcase(line)
      call cutst(line,lenp,dire,lend)
c
      j=2
      do 10 i=1,10
      if (digit(i:i).eq.dire(2:2)) j=1
   10 continue
      buf2(1:2)=blank//blank
      buf2(1:j)=dire(1:j)
      iz=0
      do 20 i=1,nk
      write(buf1,'(a2)') nalf(i)
      if (buf1.eq.buf2) iz=i
   20 continue
      if (iz.eq.0) then
                     if (buf2(1:1).eq.'q') then
                                             iz=9
                                           else
                                             ier=-1
                                           endif
                   endif
      if (kjump.eq.0) then
                        do 30 i=1,j
                        dire(i:i)=blank
   30                   continue
                        call shift(dire,lend)
                        iopt=0
                        call getnum(dire,vet,ivet,iv,iopt)
                        if (iopt.eq.-1.or.iv.eq.0) ier=-1
                        ncod=ivet(1)
                      endif
c
      return
      end
c----------------------------------------------------------------------
      subroutine change0(ier)
      character buf1*2,buf2*2,buf3*2
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,kat,f(9),nalf(8)
      common /buffer/ ndel(200),niz(200),nop,dummr(114)
c
      nchange=0
      do 100 i=1,nats
      if (ndel(i).lt.0) then
         iz=iabs(nz(i)/100)
         iz1=niz(i)
         if (iz.eq.0) then
                        iz=9
                        buf1(1:2)='q '
                      else
                        write(buf1,'(a2)') nalf(iz)
                      endif
         if (iz1.eq.9) then
                        buf2(1:2)='q '
                      else
                        write(buf2,'(a2)') nalf(iz1)
                      endif
         call ucase(buf1(1:1))
         call ucase(buf2(1:1))
         if (iz.eq.iz1) then
                           nchange=nchange+1
                           write(lo,800) buf2,i
                         else
                           ndel(i)=0
                           write(lo,810) buf2,i
                         endif
                        endif
  100 continue
      do 200 i=1,nats
      if (ndel(i).gt.0) then
         iz=iabs(nz(i)/100)
         iz1=niz(i)
         iz2=ndel(i)
         if (iz.eq.0) then
                        iz=9
                        buf1(1:2)='q '
                      else
                        write(buf1,'(a2)') nalf(iz)
                      endif
         if (iz1.eq.9) then
                        buf2(1:2)='q '
                      else
                        write(buf2,'(a2)') nalf(iz1)
                      endif
         write(buf3,'(a2)') nalf(iz2)
         call ucase(buf1(1:1))
         call ucase(buf2(1:1))
         call ucase(buf3(1:1))
         if (iz.eq.iz1.or.iz.eq.9) then
                          nchange=nchange+1
                          write(lo,820) buf2,i,buf3,i
                        else
                          ndel(i)=0
                          write(lo,830) buf2,i
                        endif
                        endif
  200 continue
      if (nchange.eq.0) write(lo,900)
  800 format('     Atom ',a2,i3,' has been deleted')
  810 format(' *** Atom ',a2,i3,' does not exist. Cannot be deleted')
  820 format('     Atom ',a2,i3,' has been renamed as ',a2,i3)
  830 format(' *** Atom ',a2,i3,' does not exist. Cannot be renamed')
  900 format(//,' *** warning *** No changes applied to atom list',//)
c
      return
      end
c----------------------------------------------------------------------
      subroutine change1(ier)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,kat,f(9),nalf(8)
      common /buffer/ ndel(200),niz(200),nop,dummr(114)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
c
      j=0
      do 100 i=1,nats
      nd=ndel(i)
      if (nd.ge.0) then
                     j=j+1
                     do 10 k=1,5
   10                x(k,j)=x(k,i)
                     bfac(j)=bfac(i)
                     if (nd.gt.0) then
                                    nz(j)=ndel(i)*100+1
                                  else
                                    nz(j)=nz(i)
                                  endif
                   endif
  100 continue
      nats=j
      interp=0
      jrest=1
      call frm15(nats,numset,interp)
      call cp1530
c
      return
      end
c---------------------------------------------------------------------
      subroutine sftrc(mode,numb,ep)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),bold(400)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xbuil/ift1,ift2,ift3,nfl,npeahi,ngrup,nfrag,ngh,ngl
     1,dmax,dmin,g(18),dmn(9),dmx(9),dmnmx(9,9,2),angi(3),angs(3)
     2,l3dum,md,lclus,mclus,laddr,ldis,mddis,lang,lnegl,mnegl,nnegl
     3,ladcon,lcon,mcon,ncon,mdcon,ladinc,linc,minc,mdinc
     4,ive(9),ive3i(9),ive3s(9),ive15i(9),ive15s(9)
     5,icopk(9),icoel(9),icogr(500)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *             ,wt(31000),nzsav(500),occsav(500),
     *              fvar(500),q(500),qq(500),dummy(2500)
     *              ,dummpc(84000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      integer izpk(500)
      dimension vet(8),ivet(8)
      dimension ep(31000)
      equivalence(vet,ivet)
c
      coef=1.35
      coefr=1.0/3.0
      call ysfl07(nrifl,nstr,mmmz,npseud,iy)
c
      delta=1.0/12.0
c-- compute the numer of peaks to consider
      totop=(icent+1)*nsym*pts
      jlig=1
      if (no(1).eq.1) jlig=2
      anat=0.0
      do 12 i=jlig,nk
   12 anat=anat+float(nw(i))
c
c-- azzero il vettore contenente un flag (0=atomo escluso,1=preso)
c
      sum=0.0
      nne=0.0
      do 99 i=1,nats
      if (sum.le.anat) then
                         occ=x(5,i)
                         sum=sum+occ*totop
                         if ((sum-anat).lt.delta) nne=nne+1
                      endif
   99 continue
      jnats=0
      j=nats
      do 991 i=1,nats
      if (jnats.ge.nne) go to 991
      j=i
      jnats=jnats+1
  991 continue
      nne=j
      if (krecy.ne.1) then
                        call assbtl
                        call labe2(nne)
                      endif
      hei=x(4,nne)
      kzo=iabs(nz(nne)/100)
      sum=1.0
      do 97 i=1,nne-1
      if(sum.gt.2.5) go to 992
      j=nne-i
      kz=iabs(nz(j)/100)
      if (kz.eq.kzo) then
                       hei=hei+x(4,j)
                       sum=sum+1.0
                     endif
   97 continue
  992 continue
      hei=sum/hei
c
      do 98 i=1,nats
      occsav(i)=x(5,i)
      xleg=1.000
      if (i.le.nne) then
                      ww=1.00
                      wws=1.00
                    else
                      ww=x(4,i)*hei*erre**coefr
                      wws=ww*xleg
                      if (wws.le.0.3) then
                                        ww=0.0
                                        nz(i)=0
                                      endif
                    endif
      x(5,i)=x(5,i)*xleg*ww
      nz(i)=iabs(nz(i)/100)
      nzsav(i)=nz(i)
      if (iprin.gt.1) then
      if(nz(i).gt.0) then
      write(lo,9999) i,nalf(nz(i)),x(4,i),xleg,hei,erre*100.0,
     *              coefr,ww,occsav(i),x(5,i),wws
                      else
      write(lo,9998) i,x(4,i),xleg,hei,erre*100.0,
     *              coefr,ww,occsav(i),x(5,i),wws
                      endif
                      endif
   98 continue
 9999 format(i4,1h),2x,a2,2x,f8.1,4f10.3,f10.8,f6.2,f8.4,3f8.4)
 9998 format(i4,1h),6x,f8.1,4f10.3,f10.8,f6.2,f8.4,3f8.4)
c
      call pkl15(nats)
      nlsm=7
      iref=3
      call sftryyy(iref,mode,nlsm,numb,ep,scalan)
c
      do 450 i=1,nats
      nz(i)=nz(i)*100
  450 continue    
      kact=5
      call maincl(izpk,kact,iprin)
c
      maxcyc=mode-1
      interp=1
      call frm15(nats,numset,interp)
c
c-- plot
c
      mode1=mode-1
      call scrf(numset,mode1,2)
      return
      end
c-----------------------------------------------------------------------
      subroutine assbtl
c
c-- assign to atoms the thermal factor and the atomic specie 
c-- according to previous atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),bnew(500),dummy(2500)
     *              ,dummpc(84000)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension xn(3),xo(3),xeq(3),vet(2),s(3)
c
      iprsav = iprin 
      idisp=1
      call sfl30(natso,idisp,idumm,interp)
              if (iprin.gt.2) then
      write(lo,*) ' vecchia lista '
      do 1 i=1,natso
      nzzo=iabs(nzo(i)/100)
      if (nzzo.eq.0) then
	  write(lo,'(2x,2x,i5,f8.1,3f10.3)')
     *          i,xyzo(4,i),(xyzo(j,i),j=1,3)
                     else
	  write(lo,'(2x,a2,i5,f8.1,3f10.3)')
     *          nalf(nzzo),i,xyzo(4,i),(xyzo(j,i),j=1,3)
                     endif
    1 continue
      write(lo,*) ' nuova lista '
                          endif
      do 5 j=1,nats
          if (iprin.gt.2) then
          nzzo=iabs(nz(j)/100)
          if (nzzo.gt.0) then
	  write(lo,'(2x,a2,i5,f8.1,3f10.3)')
     *    nalf(nzzo),j,x(4,j),(x(k,j),k=1,3)
                         else
	  write(lo,'(2x,2x,i5,f8.1,3f10.3)')
     *               j,x(4,j),(x(k,j),k=1,3)
                         endif
                          endif
      q(j)=0.0
   5  bnew(j)=biso
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do 100 i=1,natso
      if (nzo(i).eq.0) go to 100
      nzo(i)=iabs(nzo(i)/100)
      do 10 j=1,3
   10 xo(j)=xyzo(j,i)
      distm=9999
      jpunt=0
      do 90 j=1,nats
      if (q(j).gt.0.5) go to 90
      do 20 k=1,3
   20 xn(k)=x(k,j)
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            call xequi(xo,k,coef,xeq,kt)
            call xdist(xn,xeq,d,s)
            if (d.lt.distm.and.d.lt.ddmin) then
                                             distm=d
                                             jpunt=j
                                           endif
   50 continue
   90 continue
c
      if (jpunt.ne.0) then
                        q(jpunt)=i
                        nzn=iabs(nz(jpunt)/100)
                        bnew(jpunt)=bfac(i)
                        nz(jpunt)=nzo(i)
                      endif
c
  100 continue
      if (iprin.gt.2) then
      do 110 j=1,nats
      if (nz(j).eq.0) go to 110
      nzn=iabs(nz(j))
      i=nint(q(j))
      if (i.gt.0) then
                    write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j),
c    *                          nalf(nzo(i)),i,(xyzo(k,i),k=1,3),bfac(i)
     *                               nzo(i),i,(xyzo(k,i),k=1,3),bfac(i)
                       else
                    write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j)
                       endif
  110 continue
                      endif
      do 120 j=1,nats
      bfac(j)=bnew(j)
c
c-- assign old coordinates to new peaks
c
      i=q(j)
      if (i.gt.0) then
                    do 115 jj=1,3
  115               x(jj,j)=xyzo(jj,i)
                    x(5,j)=xyzo(5,i)
                  endif
  120 continue
c  92 format(2x,a2,i4,4f10.3,10x,a2,i4,4f10.3,10x)
   92 format(2x,a2,i4,4f10.3,10x,' nalf(',i2,')',i4,4f10.3,10x)
      iprin = iprsav 
      return
      end
c--------------------------------------------------------------------------
      subroutine labe2(nne)
c
c-- subroutine to label peaks according only to
c-- the relative peak height and to the cell content
c-- ( only those atoms not previously labelled )
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),izpk(500),duma(4500)
     *              ,dummpc(84000)
c-- nw(i) = number of atoms of the i-th specie
c-- no(i) = Z of atom of the i-th specie
c-- nkl   = number of non-hydrogen species
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
c
      dimension number(8,2)
C
      do 100 i=1,nne 
      if (nz(i).eq.0) then
                        izpk(i)=0
                      else
                        izpk(i)=nk-nz(i)+1
                      endif
  100 continue
      jall=1
      t2=(icent+1)*nsym*pts
      jlig=0
      if (no(1).eq.1) jlig=1
c--NEW
      nkl=nk-jlig
c--NEW
      j=nk+1
      do 1000 i=1,nk
      j=j-1
      number(i,1)=nw(j)
      kz=no(j)
      if (kz.gt.1 ) then
                      number(i,2)=kz
                    else
                      number(i,2)=0
                    endif
 1000 continue
      do 1050 i=1,nne
      k=izpk(i)
      if (k.ne.0) then
                    numb=nint(x(5,i)*t2)
                    number(k,1)=number(k,1)-numb
                  endif
 1050 continue
c
      k=1
      heig1=x(4,1)
      z1  =float(number(1,2))
c
      do 1100 i=1,nne 
      if (izpk(i).ne.0) go to 1100
c
      do 1090 j=1,nkl
      if (number(j,1).eq.0) go to 1090
      k=j
      lasth=i-1
      numb=nint(x(5,i)*t2)
 1120 number(k,1)=number(k,1)-numb
      kz=number(k,2)
      heign=x(4,i)
      zn  =float(number(k,2))
      if (jall.eq.0.and.kz.lt.11) go to 1400
      if (number(k,1).ge.0) then
         rap=heig1*zn/z1
         rap1=rap*0.6
         rap2=rap*1.4
         if ((heign.gt.rap1.and.heign.lt.rap2).or.kz.eq.0) then
                                             izpk(i)=k
                                             if (number(k,1).eq.0) k=k+1
                                             go to 1100
                                              else
                                            number(k,1)=number(k,1)+numb
                                              endif
                            else
                              number(k,1)=number(k,1)+numb
                              k=k+1
                              if (k.le.nkl) then
                                             go to 1120
                                           else
                                             go to 1400
                                           endif
                            endif
 1090 continue
 1100 continue
      go to 1900
 1400 continue
 1900 continue
      do 2000 i=1,nne 
      if (izpk(i).eq.0) then
                          nz(i)=(jlig+1)*100 + 1
                        else
                          nz(i)=(nk-izpk(i)+1)*100 + 1
                        endif
 2000 continue
      if (nne.lt.nats) then
                         do 2100 i=nne+1,nats
                         if (nz(i).eq.0) nz(i)=(jlig+1)*100 + 1
 2100                    continue
                       endif
c
      return
      end
c--------------------------------------------------------------------------

